
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Speed
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _gADC_result=R4
	.DEF _irdiodas=R7
	.DEF _irdav=R6
	.DEF _mdav=R9
	.DEF _tsopdav=R8
	.DEF _irjautrumas=R11
	.DEF _irkartai=R10
	.DEF _Uzlaik=R13
	.DEF _davnr=R12

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer1_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _adc_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x6C:
	.DB  0xF,0x0,0x6
_0x200005F:
	.DB  0x1
_0x2000000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x03
	.DW  0x08
	.DW  _0x6C*2

	.DW  0x01
	.DW  __seed_G100
	.DW  _0x200005F*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;// eProDas  iejimu ispletimas (ROBOTO BUFERIAI)
;// Kas suveike konkreciai, nes davikliai "persidengia",
;// ivesti papildomi isvadai TSOP, MDAV, paprasti IR davikliai
;// gali buti nenaudojami, yra TSOP, kurie ganetinai patikimai veikia
;//
;// Autorius: Arnoldas Cerniakovas 2012m, Kaunas
;//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;
;#include <mega8.h> //Prijungti mk Atmega8 biblioteka
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <stdlib.h>
;#define ADC_VREF_TYPE 0x20   //  ar  0x40
;#define true 1   //  kartais nesupranta
;#define false 0   //  kartais nesupranta
;
;bit ADC_complete;     //analogas-kodas keitiklio busena kai ADC_complete==1, skaitine reiksme gADC_result jau yra...
;unsigned int gADC_result;      // analogas-kodas keitiklio reiksme
;unsigned char irdiodas;     //infraredo daviklio nr. irdiodas==0-PORTD.0=1dav. sv diodas, PORTD.1=2dav.., PORTD.2=3dav.., PORTD.3=4dav.. kartu su vieno variklio fazem
;unsigned char irdav;    //infraredo darbinio rezimo busenos kint. (i kuria puse judeti)
;unsigned char mdav;
;unsigned char tsopdav=0b00001111;
;unsigned char irjautrumas;    //infraredo jautrumo kint.
;unsigned char irkartai=6;   // kiek kartu turejo pasitikrinti ta pati davikli buvo 3
;unsigned char Uzlaik;        //timerio uzlaikymas
;bit t1=0;  // taimeris 1   , jei =1 tai laiko tarpas praejo
;unsigned int i; //tipo FOR ciklams
;unsigned int delta;     // IR daviklio kintamasis, nusakantis atstuma iki objekto
;unsigned char davnr;
;unsigned char tmp;
;unsigned char  PORTBOLD;
;unsigned char D1;   // 1 optinio davikliio suveikimo kartai
;unsigned char D2;   // 2 optinio davikliio suveikimo kartai
;unsigned char D3;   //  3 optinio davikliio suveikimo kartai
;unsigned char D4;  //   4 optinio davikliio suveikimo kartai
;// **************  Paprogramiu sarasas  *********************************************
;    static  void  delay_ns(unsigned char __count);
;    void Jautrumas ();
;    void Uzlaikymas ();
;    void IRdavnust();     //  infrared davikliu inicializacija
;    void IrDavApkl();  // infrared davikliu apklausa
;    void IrSuveikes();
;    void Tsop();
;//** Taimerio [1] perpildymo pertraukimas
;interrupt [TIM1_OVF] void timer1_ovf_isr(void){  //interrupt [TIM0_OVF] void timer0_ovf_isr(void)   //~3.4sek,kai TCNT0=0xFF; cik_sk=100;
; 0000 002D interrupt [9] void timer1_ovf_isr(void){

	.CSEG
_timer1_ovf_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 002E 
; 0000 002F       TIMSK=0x00;
	LDI  R30,LOW(0)
	OUT  0x39,R30
; 0000 0030     t1=false;
	CLT
	BLD  R2,1
; 0000 0031 
; 0000 0032 
; 0000 0033 
; 0000 0034 
; 0000 0035     }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;//##############################################################################################
;void main(void)
; 0000 0038 {// Declare your local variables here
_main:
; 0000 0039 //****************   Port B initialization
; 0000 003A PORTB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x18,R30
; 0000 003B DDRB=0x0F;
	LDI  R30,LOW(15)
	OUT  0x17,R30
; 0000 003C //****************   Port C initialization
; 0000 003D PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 003E DDRC=0x00;
	OUT  0x14,R30
; 0000 003F //****************   Port D initialization
; 0000 0040 PORTD=0b10000000;
	LDI  R30,LOW(128)
	OUT  0x12,R30
; 0000 0041 DDRD=0x01111111;
	LDI  R30,LOW(17)
	OUT  0x11,R30
; 0000 0042 //****************  ADC  initialization
; 0000 0043    IRdavnust();  //ADC nustatymas
	RCALL _IRdavnust
; 0000 0044 
; 0000 0045    // irdav=0x0F;   mdav=0x0F;    pradines
; 0000 0046   DDRD.1 = 1;  DDRD.2 =1 ; DDRD.3 = 1;  DDRD.4 = 1; DDRD.5 = 1;  DDRD.6 = 1; //  kad veiktu -> reikejo pakartoti krypti konkreciai siuos isvadus
	SBI  0x11,1
	SBI  0x11,2
	SBI  0x11,3
	SBI  0x11,4
	SBI  0x11,5
	SBI  0x11,6
; 0000 0047  #asm("sei")
	sei
; 0000 0048 while (1)
_0xF:
; 0000 0049  {
; 0000 004A       if ((!t1))  {
	SBRC R2,1
	RJMP _0x12
; 0000 004B        if  (PORTBOLD==0xFF)  {
	LDS  R26,_PORTBOLD
	CPI  R26,LOW(0xFF)
	BRNE _0x13
; 0000 004C          PORTD.4=0; // numesti, jei buvo  suveike mech davikliai
	CBI  0x12,4
; 0000 004D          PORTD.5=0;// numesti, jei buvo  suveike TSOP davikliai
	CBI  0x12,5
; 0000 004E          }
; 0000 004F          Uzlaikymas ();  //taimerio reiksme
_0x13:
	RCALL _Uzlaikymas
; 0000 0050          mdav= 0x0F; irdav= 0x0F; tsopdav= 0x0F;
	LDI  R30,LOW(15)
	MOV  R9,R30
	MOV  R6,R30
	MOV  R8,R30
; 0000 0051          D1=0; D2=0; D3=0; D4=0;
	LDI  R30,LOW(0)
	STS  _D1,R30
	STS  _D2,R30
	STS  _D3,R30
	STS  _D4,R30
; 0000 0052          }
; 0000 0053 
; 0000 0054 
; 0000 0055    if (!(PIND.5||PIND.4)||!t1){  Jautrumas (); IrSuveikes();  } //(!(PIND.5||PIND.4)||t1) jei nebuvo  suveike mech davikliai ir  TSOP davikliai
_0x12:
	SBIC 0x10,5
	RJMP _0x19
	SBIS 0x10,4
	RJMP _0x1B
_0x19:
	SBRC R2,1
	RJMP _0x18
_0x1B:
	RCALL _Jautrumas
	RCALL _IrSuveikes
; 0000 0056    // delay_ms(1);  //kas tsop-ai nereaguotu
; 0000 0057    if (!PIND.4){ Tsop();}    // jei nebuvo  suveike mech davikliai
_0x18:
	SBIS 0x10,4
	RCALL _Tsop
; 0000 0058     tmp=(0xF0&(PINB));     //mech davikliu apklausa
	IN   R30,0x16
	ANDI R30,LOW(0xF0)
	STS  _tmp,R30
; 0000 0059 
; 0000 005A       if (((tmp)<0xF0)){
	LDS  R26,_tmp
	CPI  R26,LOW(0xF0)
	BRSH _0x1E
; 0000 005B              tmp=tmp>>4;
	LDI  R31,0
	RCALL __ASRW4
	STS  _tmp,R30
; 0000 005C              mdav=(mdav&tmp)&0x0F;
	AND  R30,R9
	ANDI R30,LOW(0xF)
	MOV  R9,R30
; 0000 005D             PORTD.4=1; // patvirtinam sitam pine, kad suveike mech davikliai
	SBI  0x12,4
; 0000 005E             irdav=0x0F; tsopdav=0x0F;
	LDI  R30,LOW(15)
	MOV  R6,R30
	MOV  R8,R30
; 0000 005F           }
; 0000 0060 
; 0000 0061 
; 0000 0062       if (irdav!=0x0F) {
_0x1E:
	LDI  R30,LOW(15)
	CP   R30,R6
	BREQ _0x21
; 0000 0063          irdav=0x0F;
	MOV  R6,R30
; 0000 0064         for (i=1; i <= 10; i=i+1)  { IrSuveikes(); } // ciklas 10 daviklio patikrinimu
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _i,R30
	STS  _i+1,R31
_0x23:
	LDS  R26,_i
	LDS  R27,_i+1
	SBIW R26,11
	BRSH _0x24
	RCALL _IrSuveikes
	LDS  R30,_i
	LDS  R31,_i+1
	ADIW R30,1
	STS  _i,R30
	STS  _i+1,R31
	RJMP _0x23
_0x24:
; 0000 0065 
; 0000 0066                 if (D1>irkartai) {irdav= 0b00001110 & irdav;}        //jei > nei irkartai kartus nustatyta kliutis
	LDS  R26,_D1
	CP   R10,R26
	BRSH _0x25
	LDI  R30,LOW(14)
	AND  R6,R30
; 0000 0067                 if (D2>irkartai) {irdav= 0b00001101 & irdav;}        //jei > nei  irkartai kartus nustatyta kliutis
_0x25:
	LDS  R26,_D2
	CP   R10,R26
	BRSH _0x26
	LDI  R30,LOW(13)
	AND  R6,R30
; 0000 0068                 if (D3>irkartai){irdav= 0b00001011 & irdav;}         //jei > nei  irkartai kartus nustatyta kliutis
_0x26:
	LDS  R26,_D3
	CP   R10,R26
	BRSH _0x27
	LDI  R30,LOW(11)
	AND  R6,R30
; 0000 0069                 if (D4>irkartai){irdav= 0b00000111 & irdav;}         //jei > nei  irkartai kartus nustatyta kliutis
_0x27:
	LDS  R26,_D4
	CP   R10,R26
	BRSH _0x28
	LDI  R30,LOW(7)
	AND  R6,R30
; 0000 006A       }
_0x28:
; 0000 006B 
; 0000 006C     tmp= ((irdav)&(mdav)&(tsopdav))|0xF0; //
_0x21:
	MOV  R30,R9
	AND  R30,R6
	AND  R30,R8
	ORI  R30,LOW(0xF0)
	STS  _tmp,R30
; 0000 006D        if  (tmp!=PORTBOLD) { TIMSK=0x00;  //
	LDS  R30,_PORTBOLD
	LDS  R26,_tmp
	CP   R30,R26
	BREQ _0x29
	LDI  R30,LOW(0)
	OUT  0x39,R30
; 0000 006E         TCCR1A=0x00;TCCR1B=0x00;  TCNT1L=0x0F; TCNT1H=0x0F;
	OUT  0x2F,R30
	OUT  0x2E,R30
	LDI  R30,LOW(15)
	OUT  0x2C,R30
	OUT  0x2D,R30
; 0000 006F         ICR1L=0x00;ICR1H=0x00; OCR1AL=0x00;OCR1AH=0x00; OCR1BL=0x00; OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
	OUT  0x27,R30
	OUT  0x2A,R30
	OUT  0x2B,R30
	OUT  0x28,R30
	OUT  0x29,R30
; 0000 0070         delay_ns(10);  //  gal ir nereikia  to viso vircuj jei netesti dar karta uzlaikyno
	LDI  R30,LOW(10)
	ST   -Y,R30
	RCALL _delay_ns_G000
; 0000 0071         t1=true;TCNT1H=Uzlaik;   TCCR1B=0x04; TIMSK=0x04;}    // PORTD.6=t1;
	SET
	BLD  R2,1
	OUT  0x2D,R13
	LDI  R30,LOW(4)
	OUT  0x2E,R30
	OUT  0x39,R30
; 0000 0072 
; 0000 0073       PORTB =  tmp;
_0x29:
	LDS  R30,_tmp
	OUT  0x18,R30
; 0000 0074       PORTBOLD = tmp;
	STS  _PORTBOLD,R30
; 0000 0075 
; 0000 0076  } //while pabaiga
	RJMP _0xF
; 0000 0077 }  //main pabaiga
_0x2A:
	RJMP _0x2A
;
;//*********************  IR davikliu inicializavimas ******************************
;void IRdavnust (void)
; 0000 007B {ACSR=0x80; SFIOR=0x00;
_IRdavnust:
	LDI  R30,LOW(128)
	OUT  0x8,R30
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 007C ADMUX=ADC_VREF_TYPE & 20;//ADC Voltage Reference: AVCC pin
	OUT  0x7,R30
; 0000 007D ADCSRA=0x8F;  // 8000000/64=>0x8F 0x8C buvo //gale trys bitai:101 tai ADC_F=F/16 , 110 tai ADC_F=F/32 , 111 tai ADC_F=F/64(,   -     8B originale)
	LDI  R30,LOW(143)
	OUT  0x6,R30
; 0000 007E }
	RET
;
;//*********************  ADC pertraukimo aptarnavimas ******************************************
;interrupt [ADC_INT] void adc_isr(void) //ADC pertraukimas
; 0000 0082 {unsigned int adc_data;
_adc_isr:
	ST   -Y,R30
	IN   R30,SREG
; 0000 0083 adc_data=ADCW;
	RCALL __SAVELOCR2
;	adc_data -> R16,R17
	__INWR 16,17,4
; 0000 0084 gADC_result=adc_data; //ADC reiksme
	MOVW R4,R16
; 0000 0085 ADC_complete=1;// nustatom veliavele
	SET
	BLD  R2,0
; 0000 0086 }
	RCALL __LOADLOCR2P
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;//*********************  IR davikliu apklausa ******************************************
;void IrDavApkl(void)  //
; 0000 008A {ADMUX=(ADC_VREF_TYPE & 20)|irdiodas; //perjungiam i PC i-taji
_IrDavApkl:
	MOV  R30,R7
	OUT  0x7,R30
; 0000 008B PORTD=davnr|PORTD|0b10000000;            //leidimas sviesos diodams
	IN   R30,0x12
	OR   R30,R12
	ORI  R30,0x80
	OUT  0x12,R30
; 0000 008C delay_us(100);        //laukiam pakol nusistoves svietimas
	__DELAY_USW 200
; 0000 008D ADCSRA|=0x40;         //paleisti adc
	SBI  0x6,6
; 0000 008E while(ADC_complete!=1); //ar adc pabaige - laukiam
_0x2B:
	SBRS R2,0
	RJMP _0x2B
; 0000 008F delta=gADC_result;
	__PUTWMRN _delta,0,4,5
; 0000 0090 ADC_complete=0;		//numetam adc velevele
	CLT
	BLD  R2,0
; 0000 0091 PORTD=0xF0&PORTD|0b10000000;		//isjungti IR LED
	IN   R30,0x12
	ANDI R30,LOW(0xF0)
	ORI  R30,0x80
	OUT  0x12,R30
; 0000 0092 delay_us(10);     //laukiam pakol nusistoves ...
	__DELAY_USB 27
; 0000 0093 ADCSRA|=0x40;    //paleisti adc
	SBI  0x6,6
; 0000 0094 while(ADC_complete!=1);  //ar adc pabaige
_0x2E:
	SBRS R2,0
	RJMP _0x2E
; 0000 0095 delta=abs(gADC_result-delta);//;   skirtumas  tarp apsviesto ir tamsaus IR led
	LDS  R26,_delta
	LDS  R27,_delta+1
	MOVW R30,R4
	SUB  R30,R26
	SBC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	RCALL _abs
	STS  _delta,R30
	STS  _delta+1,R31
; 0000 0096 ADC_complete=0;		//numetam adc velevele
	CLT
	BLD  R2,0
; 0000 0097 
; 0000 0098 if (delta>irjautrumas){
	MOV  R30,R11
	LDS  R26,_delta
	LDS  R27,_delta+1
	LDI  R31,0
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x31
; 0000 0099 //****judejimo krypties priskyrimas nuo optiniu davikliu****
; 0000 009A 
; 0000 009B  if (irdiodas==0) irdav= irdav & 0b00001110;
	TST  R7
	BRNE _0x32
	LDI  R30,LOW(14)
	AND  R6,R30
; 0000 009C  if (irdiodas==1) irdav= irdav & 0b00001101;
_0x32:
	LDI  R30,LOW(1)
	CP   R30,R7
	BRNE _0x33
	LDI  R30,LOW(13)
	AND  R6,R30
; 0000 009D  if (irdiodas==2) irdav= irdav & 0b00001011;
_0x33:
	LDI  R30,LOW(2)
	CP   R30,R7
	BRNE _0x34
	LDI  R30,LOW(11)
	AND  R6,R30
; 0000 009E  if (irdiodas==3) irdav= irdav & 0b00000111;
_0x34:
	LDI  R30,LOW(3)
	CP   R30,R7
	BRNE _0x35
	LDI  R30,LOW(7)
	AND  R6,R30
; 0000 009F  }
_0x35:
; 0000 00A0 }
_0x31:
	RET
;
;//*********************  irjautrumas ******************************************
;void Jautrumas (void)
; 0000 00A4 {ADMUX=(ADC_VREF_TYPE & 20) | 04; //perjungiam adc i PC4
_Jautrumas:
	LDI  R30,LOW(4)
	OUT  0x7,R30
; 0000 00A5  ADCSRA|=0x40;
	SBI  0x6,6
; 0000 00A6 while(ADC_complete!=1);
_0x36:
	SBRS R2,0
	RJMP _0x36
; 0000 00A7 irjautrumas=(unsigned char)(gADC_result>>5);//
	MOVW R26,R4
	LDI  R30,LOW(5)
	RCALL __LSRW12
	MOV  R11,R30
; 0000 00A8 ADC_complete=0;		//numetam adc velevele
	RJMP _0x2080001
; 0000 00A9 }
;
;//*********************  Uzlaikymas ******************************************
;void Uzlaikymas (void)
; 0000 00AD {ADMUX=(ADC_VREF_TYPE & 20)|05; //perjungiam adc i PA5
_Uzlaikymas:
	LDI  R30,LOW(5)
	OUT  0x7,R30
; 0000 00AE ADCSRA|=0x40;
	SBI  0x6,6
; 0000 00AF while(ADC_complete!=1);
_0x39:
	SBRS R2,0
	RJMP _0x39
; 0000 00B0 Uzlaik=(unsigned char)((gADC_result>>2));//
	MOVW R30,R4
	RCALL __LSRW2
	MOV  R13,R30
; 0000 00B1 ADC_complete=0;	}	//numetam adc velevele
_0x2080001:
	CLT
	BLD  R2,0
	RET
;//********************* Filtras **********************************************
;void IrSuveikes (void)
; 0000 00B4  {      davnr=0b00000001; irdiodas=0;
_IrSuveikes:
	LDI  R30,LOW(1)
	MOV  R12,R30
	CLR  R7
; 0000 00B5         IrDavApkl();
	RCALL _IrDavApkl
; 0000 00B6      if (! (irdav) & (davnr))  D1=D1+1  ;
	MOV  R30,R6
	RCALL __LNEGB1
	AND  R30,R12
	BREQ _0x3C
	LDS  R30,_D1
	SUBI R30,-LOW(1)
	STS  _D1,R30
; 0000 00B7         davnr=0b00000010; irdiodas=1;
_0x3C:
	LDI  R30,LOW(2)
	MOV  R12,R30
	LDI  R30,LOW(1)
	MOV  R7,R30
; 0000 00B8         IrDavApkl();
	RCALL _IrDavApkl
; 0000 00B9      if (! (irdav) & (davnr))  D2=D2+1  ;
	MOV  R30,R6
	RCALL __LNEGB1
	AND  R30,R12
	BREQ _0x3D
	LDS  R30,_D2
	SUBI R30,-LOW(1)
	STS  _D2,R30
; 0000 00BA         davnr=0b00000100;   irdiodas=2;
_0x3D:
	LDI  R30,LOW(4)
	MOV  R12,R30
	LDI  R30,LOW(2)
	MOV  R7,R30
; 0000 00BB         IrDavApkl();
	RCALL _IrDavApkl
; 0000 00BC      if (! (irdav) & (davnr))  D3=D3+1  ;
	MOV  R30,R6
	RCALL __LNEGB1
	AND  R30,R12
	BREQ _0x3E
	LDS  R30,_D3
	SUBI R30,-LOW(1)
	STS  _D3,R30
; 0000 00BD         davnr=0b00001000; irdiodas=3;
_0x3E:
	LDI  R30,LOW(8)
	MOV  R12,R30
	LDI  R30,LOW(3)
	MOV  R7,R30
; 0000 00BE         IrDavApkl();
	RCALL _IrDavApkl
; 0000 00BF      if (! (irdav) & (davnr))  D4=D4+1  ;
	MOV  R30,R6
	RCALL __LNEGB1
	AND  R30,R12
	BREQ _0x3F
	LDS  R30,_D4
	SUBI R30,-LOW(1)
	STS  _D4,R30
; 0000 00C0 }
_0x3F:
	RET
;//*********************  TSOP apklausa ******************************************
; void Tsop(void)
; 0000 00C3  {  delay_ms(1);  tmp=0;
_Tsop:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	LDI  R30,LOW(0)
	STS  _tmp,R30
; 0000 00C4     // ciklas 30 siuntimu i TSOP-a 36KHz   priekis 1 dav
; 0000 00C5    for (i=1; i <= 30; i=i+1)
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _i,R30
	STS  _i+1,R31
_0x41:
	LDS  R26,_i
	LDS  R27,_i+1
	SBIW R26,31
	BRSH _0x42
; 0000 00C6     {    PORTD.0=1; // uzdegam priekini 1dav
	SBI  0x12,0
; 0000 00C7         #asm("nop");
	nop
; 0000 00C8         delay_ns(22);    //reikia 13.89 us  prie 22 ir 19 36585Hz
	LDI  R30,LOW(22)
	ST   -Y,R30
	RCALL _delay_ns_G000
; 0000 00C9       if (!PIND.7) {  tmp=tmp+1; } //pakabinti abudu TSOP-ai ant vieno iejimo !!!!
	SBIC 0x10,7
	RJMP _0x45
	LDS  R30,_tmp
	SUBI R30,-LOW(1)
	STS  _tmp,R30
; 0000 00CA         PORTD.0=0; //PORTD.1=0; gesinam priekinius PORTD.2=1; PORTD.3=1;
_0x45:
	CBI  0x12,0
; 0000 00CB         delay_ns(19); #asm("nop");}
	LDI  R30,LOW(19)
	ST   -Y,R30
	RCALL _delay_ns_G000
	nop
	LDS  R30,_i
	LDS  R31,_i+1
	ADIW R30,1
	STS  _i,R30
	STS  _i+1,R31
	RJMP _0x41
_0x42:
; 0000 00CC 
; 0000 00CD      if (tmp>15){tsopdav= 0b00001110&tsopdav;  irdav= 0x0F; PORTD.5=1;}
	LDS  R26,_tmp
	CPI  R26,LOW(0x10)
	BRLO _0x48
	LDI  R30,LOW(14)
	AND  R8,R30
	LDI  R30,LOW(15)
	MOV  R6,R30
	SBI  0x12,5
; 0000 00CE 
; 0000 00CF 
; 0000 00D0        delay_ms(1);   tmp=0;
_0x48:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	LDI  R30,LOW(0)
	STS  _tmp,R30
; 0000 00D1      // ciklas 30 siuntimu i TSOP-a 36KHz   priekis    2 dav
; 0000 00D2    for (i=1; i <= 30; i=i+1)
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _i,R30
	STS  _i+1,R31
_0x4C:
	LDS  R26,_i
	LDS  R27,_i+1
	SBIW R26,31
	BRSH _0x4D
; 0000 00D3     {PORTD.1=1; //PORTD.1=1; uzdegam priekinius PORTD.2=1; PORTD.3=1;
	SBI  0x12,1
; 0000 00D4          #asm("nop"); delay_ns(22);
	nop
	LDI  R30,LOW(22)
	ST   -Y,R30
	RCALL _delay_ns_G000
; 0000 00D5       if (!PIND.7) { tmp=tmp+1; } //pakabinti abudu TSOP-ai ant vieno iejimo
	SBIC 0x10,7
	RJMP _0x50
	LDS  R30,_tmp
	SUBI R30,-LOW(1)
	STS  _tmp,R30
; 0000 00D6          PORTD.1=0; //PORTD.1=0; gesinam priekinius PORTD.2=1; PORTD.3=1;
_0x50:
	CBI  0x12,1
; 0000 00D7         delay_ns(19);  #asm("nop");}
	LDI  R30,LOW(19)
	ST   -Y,R30
	RCALL _delay_ns_G000
	nop
	LDS  R30,_i
	LDS  R31,_i+1
	ADIW R30,1
	STS  _i,R30
	STS  _i+1,R31
	RJMP _0x4C
_0x4D:
; 0000 00D8 
; 0000 00D9        if (tmp>15) { tsopdav= 0b00001101&tsopdav;   irdav= 0x0F;  PORTD.5=1;}
	LDS  R26,_tmp
	CPI  R26,LOW(0x10)
	BRLO _0x53
	LDI  R30,LOW(13)
	AND  R8,R30
	LDI  R30,LOW(15)
	MOV  R6,R30
	SBI  0x12,5
; 0000 00DA 
; 0000 00DB 
; 0000 00DC       delay_ms(1);  tmp=0;
_0x53:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	LDI  R30,LOW(0)
	STS  _tmp,R30
; 0000 00DD      // ciklas 30 siuntimu i TSOP-a 38KHz    galas 1 dav
; 0000 00DE      for (i=1; i <= 30; i=i+1)
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _i,R30
	STS  _i+1,R31
_0x57:
	LDS  R26,_i
	LDS  R27,_i+1
	SBIW R26,31
	BRSH _0x58
; 0000 00DF       {  PORTD.2=1; //PORTD.3=1; uzdegam galinius PORTD.2=1; PORTD.3=1;
	SBI  0x12,2
; 0000 00E0         delay_ns(21);         //reikia 13.16 us
	LDI  R30,LOW(21)
	ST   -Y,R30
	RCALL _delay_ns_G000
; 0000 00E1        if (!PIND.7) {  tmp=tmp+1;  } //pakabinti abudu TSOP-ai ant vieno iejimo
	SBIC 0x10,7
	RJMP _0x5B
	LDS  R30,_tmp
	SUBI R30,-LOW(1)
	STS  _tmp,R30
; 0000 00E2          PORTD.2=0; //PORTD.3=0; gesinam galinius PORTD.2=1; PORTD.3=1;
_0x5B:
	CBI  0x12,2
; 0000 00E3          delay_ns(18); }
	LDI  R30,LOW(18)
	ST   -Y,R30
	RCALL _delay_ns_G000
	LDS  R30,_i
	LDS  R31,_i+1
	ADIW R30,1
	STS  _i,R30
	STS  _i+1,R31
	RJMP _0x57
_0x58:
; 0000 00E4 
; 0000 00E5        if (tmp>15) {tsopdav=  0b00001011&tsopdav;  irdav= 0x0F;PORTD.5=1;}
	LDS  R26,_tmp
	CPI  R26,LOW(0x10)
	BRLO _0x5E
	LDI  R30,LOW(11)
	AND  R8,R30
	LDI  R30,LOW(15)
	MOV  R6,R30
	SBI  0x12,5
; 0000 00E6 
; 0000 00E7 
; 0000 00E8         delay_ms(1);  tmp=0;
_0x5E:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	LDI  R30,LOW(0)
	STS  _tmp,R30
; 0000 00E9      // ciklas 30 siuntimu i TSOP-a 38KHz    galas 2 dav
; 0000 00EA     for (i=1; i <= 30; i=i+1)
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _i,R30
	STS  _i+1,R31
_0x62:
	LDS  R26,_i
	LDS  R27,_i+1
	SBIW R26,31
	BRSH _0x63
; 0000 00EB      {  PORTD.3=1; //PORTD.2=1; uzdegam galinius PORTD.2=1; PORTD.3=1;
	SBI  0x12,3
; 0000 00EC         delay_ns(21);  //37975Hz 21 ir 18
	LDI  R30,LOW(21)
	ST   -Y,R30
	RCALL _delay_ns_G000
; 0000 00ED        if (!PIND.7) { tmp=tmp+1;} //pakabinti abudu TSOP-ai ant vieno iejimo
	SBIC 0x10,7
	RJMP _0x66
	LDS  R30,_tmp
	SUBI R30,-LOW(1)
	STS  _tmp,R30
; 0000 00EE          PORTD.3=0; // PORTD.2=0;gesinam galinius PORTD.2=1; PORTD.3=1;
_0x66:
	CBI  0x12,3
; 0000 00EF         delay_ns(18);}
	LDI  R30,LOW(18)
	ST   -Y,R30
	RCALL _delay_ns_G000
	LDS  R30,_i
	LDS  R31,_i+1
	ADIW R30,1
	STS  _i,R30
	STS  _i+1,R31
	RJMP _0x62
_0x63:
; 0000 00F0 
; 0000 00F1        if (tmp>15) {tsopdav=  0b00000111&tsopdav;  irdav= 0x0F;PORTD.5=1;}
	LDS  R26,_tmp
	CPI  R26,LOW(0x10)
	BRLO _0x69
	LDI  R30,LOW(7)
	AND  R8,R30
	LDI  R30,LOW(15)
	MOV  R6,R30
	SBI  0x12,5
; 0000 00F2 
; 0000 00F3  }
_0x69:
	RET
;//*********************  Uzlaikymas ns 22vienetu~13us******************************************
;static  void  delay_ns(char __count)
; 0000 00F6 {#asm  volatile
_delay_ns_G000:
;	__count -> Y+0
; 0000 00F7             ld r26,y;
            ld r26,y;
; 0000 00F8  _zyme:     dec r26;
 _zyme:     dec r26;
; 0000 00F9                nop;
               nop;
; 0000 00FA             brne  _zyme;
            brne  _zyme;
; 0000 00FB #endasm
; 0000 00FC __count=0;
	LDI  R30,LOW(0)
	ST   Y,R30
; 0000 00FD }
	ADIW R28,1
	RET

	.CSEG
_abs:
    ld   r30,y+
    ld   r31,y+
    sbiw r30,0
    brpl __abs0
    com  r30
    com  r31
    adiw r30,1
__abs0:
    ret

	.DSEG

	.CSEG

	.CSEG

	.CSEG

	.CSEG

	.DSEG
_i:
	.BYTE 0x2
_delta:
	.BYTE 0x2
_tmp:
	.BYTE 0x1
_PORTBOLD:
	.BYTE 0x1
_D1:
	.BYTE 0x1
_D2:
	.BYTE 0x1
_D3:
	.BYTE 0x1
_D4:
	.BYTE 0x1
__seed_G100:
	.BYTE 0x4

	.CSEG

	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__LSRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSRW12R
__LSRW12L:
	LSR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRW12L
__LSRW12R:
	RET

__ASRW4:
	ASR  R31
	ROR  R30
__ASRW3:
	ASR  R31
	ROR  R30
__ASRW2:
	ASR  R31
	ROR  R30
	ASR  R31
	ROR  R30
	RET

__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__LNEGB1:
	TST  R30
	LDI  R30,1
	BREQ __LNEGB1F
	CLR  R30
__LNEGB1F:
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
