
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Speed
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _gADC_result=R4
	.DEF _mdav=R7
	.DEF _mdav2=R6
	.DEF _mdav3=R9
	.DEF _idav=R8
	.DEF _Uzlaik=R11
	.DEF _davnr=R10
	.DEF _tmp=R13
	.DEF _PORTBOLD=R12

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer1_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _adc_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x3:
	.DB  0x5,0xA,0xF,0x19
_0x20:
	.DB  0xF
_0x200005F:
	.DB  0x1
_0x2000000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x04
	.DW  _lygispr
	.DW  _0x3*2

	.DW  0x01
	.DW  0x06
	.DW  _0x20*2

	.DW  0x01
	.DW  __seed_G100
	.DW  _0x200005F*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;// SSC32 4 bitu iejimu ispletimas  (3+3)  + 4
;// Kas suveike konkreciai, nes davikliai "persidengia",
;// galima perpatikrinti su SSC32 roboto valdymo programa
;// Autorius: Arnoldas Cerniakovas 2012m, Kaunas
;//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;#include <mega8.h> //Prijungti mk Atmega8 biblioteka
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <stdlib.h>
;#define ADC_VREF_TYPE 0x20   //  ar  0x40
;#define true 1   //  kartais nesupranta
;#define false 0   //  kartais nesupranta
;
;bit ADC_complete;     //analogas-kodas keitiklio busena kai ADC_complete==1, skaitine reiksme gADC_result jau yra...
;unsigned int gADC_result;      // analogas-kodas keitiklio reiksme
;//unsigned char mdav1;    //
;unsigned char mdav;
;unsigned char mdav2=0b00001111;
;unsigned char mdav3;
;unsigned char idav;   //sroves davikliai
;unsigned char Uzlaik; //timerio uzlaikymas
;unsigned char davnr;
;bit t1=0;  // taimeris 1   , jei =1 tai laiko tarpas praejo
;unsigned char tmp;
;unsigned char  PORTBOLD;
;unsigned char  kanalas;
;unsigned char lygispr[]={5,10,15,25};    //adc suveikimo pradiniai lygiai  pagal konkrecius varikliu galingumus

	.DSEG
;unsigned char lygis[]={0,0,0,0};    //adc suveikimo lygiai  pagal konkrecius varikliu galingumus
;unsigned int adcjautrumas;
;
;// **************  Paprogramiu sarasas  *********************************************
;    static  void  delay_ns(unsigned char __count);
;    void Uzlaikymas ();
;    void adcnust();     //  infrared davikliu inicializacija
;   void adcDavApkl();
;   void Jautrumas();
;   void adcSuveikes();
;
;//** Taimerio [1] perpildymo pertraukimas
;interrupt [TIM1_OVF] void timer1_ovf_isr(void){  //interrupt [TIM0_OVF] void timer0_ovf_isr(void)   //~3.4sek,kai TCNT0=0xFF; cik_sk=100;
; 0000 0028 interrupt [9] void timer1_ovf_isr(void){

	.CSEG
_timer1_ovf_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 0029       TIMSK=0x00;
	LDI  R30,LOW(0)
	OUT  0x39,R30
; 0000 002A     t1=false;
	CLT
	BLD  R2,1
; 0000 002B     //  idav= 0x0F;
; 0000 002C     }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;//##############################################################################################
;void main(void)
; 0000 002F {// Declare your local variables here
_main:
; 0000 0030 
; 0000 0031 
; 0000 0032 //****************   Port B initialization
; 0000 0033 PORTB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x18,R30
; 0000 0034 DDRB=0x0F;
	LDI  R30,LOW(15)
	OUT  0x17,R30
; 0000 0035 //****************   Port C initialization
; 0000 0036 PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 0037 DDRC=0x00;
	OUT  0x14,R30
; 0000 0038 //****************   Port D initialization
; 0000 0039 PORTD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x12,R30
; 0000 003A DDRD=0x00;
	LDI  R30,LOW(0)
	OUT  0x11,R30
; 0000 003B //****************  ADC  initialization
; 0000 003C    adcnust();  //ADC nustatymas
	RCALL _adcnust
; 0000 003D 
; 0000 003E  #asm("sei")
	sei
; 0000 003F while (1)
_0x4:
; 0000 0040  {
; 0000 0041       if (!t1)  {Uzlaikymas (); Jautrumas();  //taimerio reiksme
	SBRC R2,1
	RJMP _0x7
	RCALL _Uzlaikymas
	RCALL _Jautrumas
; 0000 0042          mdav= 0x0F; mdav3= 0x0F; mdav2= 0x0F; idav= 0x0F;
	LDI  R30,LOW(15)
	MOV  R7,R30
	MOV  R9,R30
	MOV  R6,R30
	MOV  R8,R30
; 0000 0043          PORTB=0xFF;  }
	LDI  R30,LOW(255)
	OUT  0x18,R30
; 0000 0044 
; 0000 0045    tmp=(0xF0&(PINB));     //mech davikliu 0 apklausa
_0x7:
	IN   R30,0x16
	ANDI R30,LOW(0xF0)
	MOV  R13,R30
; 0000 0046       if (((tmp)<0xF0)){    tmp=tmp>>4; mdav=(mdav&tmp)&0x0F;  }
	LDI  R30,LOW(240)
	CP   R13,R30
	BRSH _0x8
	MOV  R30,R13
	LDI  R31,0
	RCALL __ASRW4
	MOV  R13,R30
	MOV  R30,R13
	AND  R30,R7
	ANDI R30,LOW(0xF)
	MOV  R7,R30
; 0000 0047 
; 0000 0048    tmp=(0x0F&(PIND));     //mech davikliu 2 apklausa
_0x8:
	IN   R30,0x10
	ANDI R30,LOW(0xF)
	MOV  R13,R30
; 0000 0049       if (((tmp)<0x0F)){  mdav2=(mdav2&tmp);}
	LDI  R30,LOW(15)
	CP   R13,R30
	BRSH _0x9
	AND  R6,R13
; 0000 004A 
; 0000 004B     tmp=(0xF0&(PIND));     //mech davikliu 3 apklausa
_0x9:
	IN   R30,0x10
	ANDI R30,LOW(0xF0)
	MOV  R13,R30
; 0000 004C       if (((tmp)<0xF0)){   tmp=tmp>>4;  mdav3=(mdav3&tmp); }
	LDI  R30,LOW(240)
	CP   R13,R30
	BRSH _0xA
	MOV  R30,R13
	LDI  R31,0
	RCALL __ASRW4
	MOV  R13,R30
	AND  R9,R13
; 0000 004D 
; 0000 004E      adcSuveikes();  //apkrovu tikrinimas
_0xA:
	RCALL _adcSuveikes
; 0000 004F     tmp= ((mdav)&(mdav2)&(mdav3))|0xF0; //
	MOV  R30,R6
	AND  R30,R7
	AND  R30,R9
	ORI  R30,LOW(0xF0)
	MOV  R13,R30
; 0000 0050    if  (((idav)<0x0F)){  tmp= ((idav)&(tmp)&(0b11110111))|0xF0;} //
	LDI  R30,LOW(15)
	CP   R8,R30
	BRSH _0xB
	MOV  R30,R13
	AND  R30,R8
	ANDI R30,0XF7
	ORI  R30,LOW(0xF0)
	MOV  R13,R30
; 0000 0051 
; 0000 0052        if  (tmp!=PORTBOLD) { TIMSK=0x00;  //
_0xB:
	CP   R12,R13
	BREQ _0xC
	LDI  R30,LOW(0)
	OUT  0x39,R30
; 0000 0053         TCCR1A=0x00;TCCR1B=0x00;  TCNT1L=0x0F; TCNT1H=0x0F;
	OUT  0x2F,R30
	OUT  0x2E,R30
	LDI  R30,LOW(15)
	OUT  0x2C,R30
	OUT  0x2D,R30
; 0000 0054         ICR1L=0x00;ICR1H=0x00; OCR1AL=0x00;OCR1AH=0x00; OCR1BL=0x00; OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
	OUT  0x27,R30
	OUT  0x2A,R30
	OUT  0x2B,R30
	OUT  0x28,R30
	OUT  0x29,R30
; 0000 0055         delay_ns(10);  //  gal ir nereikia  to viso vircuj jei netesti dar karta uzlaikyno
	LDI  R30,LOW(10)
	ST   -Y,R30
	RCALL _delay_ns_G000
; 0000 0056         t1=true;TCNT1H=Uzlaik;   TCCR1B=0x04; TIMSK=0x04;
	SET
	BLD  R2,1
	OUT  0x2D,R11
	LDI  R30,LOW(4)
	OUT  0x2E,R30
	OUT  0x39,R30
; 0000 0057        }    // PORTD.6=t1;
; 0000 0058 
; 0000 0059       PORTB =  tmp;
_0xC:
	OUT  0x18,R13
; 0000 005A       PORTBOLD = tmp;
	MOV  R12,R13
; 0000 005B 
; 0000 005C  } //while pabaiga
	RJMP _0x4
; 0000 005D }  //main pabaiga
_0xD:
	RJMP _0xD
;
;//*********************  ADC inicializavimas ******************************
;void adcnust (void)
; 0000 0061 {ACSR=0x80; SFIOR=0x00;
_adcnust:
	LDI  R30,LOW(128)
	OUT  0x8,R30
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 0062 ADMUX=ADC_VREF_TYPE & 20;//ADC Voltage Reference: AVCC pin
	OUT  0x7,R30
; 0000 0063 ADCSRA=0x8F;  // 8000000/64=>0x8F 0x8C buvo //gale trys bitai:101 tai ADC_F=F/16 , 110 tai ADC_F=F/32 , 111 tai ADC_F=F/64(,   -     8B originale)
	LDI  R30,LOW(143)
	OUT  0x6,R30
; 0000 0064 }
	RET
;
;//*********************  ADC pertraukimo aptarnavimas ******************************************
;interrupt [ADC_INT] void adc_isr(void) //ADC pertraukimas
; 0000 0068 {unsigned int adc_data;
_adc_isr:
	ST   -Y,R30
	IN   R30,SREG
; 0000 0069 adc_data=ADCW;
	RCALL __SAVELOCR2
;	adc_data -> R16,R17
	__INWR 16,17,4
; 0000 006A gADC_result=adc_data; //ADC reiksme
	MOVW R4,R16
; 0000 006B ADC_complete=1;// nustatom veliavele
	SET
	BLD  R2,0
; 0000 006C }
	RCALL __LOADLOCR2P
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;
;//*********************  Uzlaikymas ******************************************
;void Uzlaikymas (void)
; 0000 0071 {ADMUX=(ADC_VREF_TYPE & 20)|05; //perjungiam adc i PA5
_Uzlaikymas:
	LDI  R30,LOW(5)
	OUT  0x7,R30
; 0000 0072 ADCSRA|=0x40;
	SBI  0x6,6
; 0000 0073 while(ADC_complete!=1);
_0xE:
	SBRS R2,0
	RJMP _0xE
; 0000 0074 Uzlaik=(unsigned char)((gADC_result>>2));//
	MOVW R30,R4
	RCALL __LSRW2
	MOV  R11,R30
; 0000 0075 ADC_complete=0;	}	//numetam adc velevele
	CLT
	BLD  R2,0
	RET
;
;//*********************  IR davikliu apklausa ******************************************
;void adcDavApkl(void)  //
; 0000 0079 {ADMUX=(ADC_VREF_TYPE & 20)|kanalas; //perjungiam i PC i-taji
_adcDavApkl:
	LDS  R30,_kanalas
	OUT  0x7,R30
; 0000 007A ADCSRA|=0x40;         //paleisti adc
	SBI  0x6,6
; 0000 007B while(ADC_complete!=1); //ar adc pabaige - laukiam
_0x11:
	SBRS R2,0
	RJMP _0x11
; 0000 007C ADC_complete=0;		//numetam adc velevele
	CLT
	BLD  R2,0
; 0000 007D 
; 0000 007E if (gADC_result>lygis[kanalas]){
	LDS  R30,_kanalas
	LDI  R31,0
	SUBI R30,LOW(-_lygis)
	SBCI R31,HIGH(-_lygis)
	LD   R30,Z
	MOVW R26,R4
	LDI  R31,0
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x14
; 0000 007F //****kur virsyja srove****
; 0000 0080  if (kanalas==0) idav= idav & 0b00001110;
	LDS  R30,_kanalas
	CPI  R30,0
	BRNE _0x15
	LDI  R30,LOW(14)
	AND  R8,R30
; 0000 0081  if (kanalas==1) idav= idav & 0b00001101;
_0x15:
	LDS  R26,_kanalas
	CPI  R26,LOW(0x1)
	BRNE _0x16
	LDI  R30,LOW(13)
	AND  R8,R30
; 0000 0082  if (kanalas==2) idav= idav & 0b00001011;
_0x16:
	LDS  R26,_kanalas
	CPI  R26,LOW(0x2)
	BRNE _0x17
	LDI  R30,LOW(11)
	AND  R8,R30
; 0000 0083  if (kanalas==3) idav= idav & 0b00000111;
_0x17:
	LDS  R26,_kanalas
	CPI  R26,LOW(0x3)
	BRNE _0x18
	LDI  R30,LOW(7)
	AND  R8,R30
; 0000 0084  }
_0x18:
; 0000 0085 }
_0x14:
	RET
;
;//*********************  adc jautrumas ******************************************
;void Jautrumas (void)
; 0000 0089 {ADMUX=(ADC_VREF_TYPE & 20) | 04; //perjungiam adc i PC4
_Jautrumas:
	LDI  R30,LOW(4)
	OUT  0x7,R30
; 0000 008A  ADCSRA|=0x40;
	SBI  0x6,6
; 0000 008B while(ADC_complete!=1);
_0x19:
	SBRS R2,0
	RJMP _0x19
; 0000 008C adcjautrumas=(gADC_result);//
	__PUTWMRN _adcjautrumas,0,4,5
; 0000 008D ADC_complete=0;		//numetam adc velevele
	CLT
	BLD  R2,0
; 0000 008E lygis[0]=lygispr[0]+adcjautrumas/128; //paskui reikes subalansuoti skaicius realiom apkrovom
	LDS  R26,_adcjautrumas
	LDS  R27,_adcjautrumas+1
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	RCALL __DIVW21U
	LDS  R26,_lygispr
	ADD  R30,R26
	STS  _lygis,R30
; 0000 008F lygis[1]=lygispr[1]+adcjautrumas/64; //paskui reikes subalabnuoti skaicius realiom apkrovom
	LDS  R26,_adcjautrumas
	LDS  R27,_adcjautrumas+1
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
	RCALL __DIVW21U
	__GETB2MN _lygispr,1
	ADD  R30,R26
	__PUTB1MN _lygis,1
; 0000 0090 lygis[2]=lygispr[2]+adcjautrumas/32 ; //paskui reikes subalansuoti skaicius realiom apkrovom
	LDS  R26,_adcjautrumas
	LDS  R27,_adcjautrumas+1
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	RCALL __DIVW21U
	__GETB2MN _lygispr,2
	ADD  R30,R26
	__PUTB1MN _lygis,2
; 0000 0091 lygis[3]=lygispr[3]+ adcjautrumas/16; //paskui reikes subalansuoti skaicius realiom apkrovom
	__GETB2MN _lygispr,3
	LDS  R30,_adcjautrumas
	LDS  R31,_adcjautrumas+1
	RCALL __LSRW4
	ADD  R30,R26
	__PUTB1MN _lygis,3
; 0000 0092 }
	RET
;
;//********************* adc Suveikes **********************************************
;void adcSuveikes (void)
; 0000 0096  {
_adcSuveikes:
; 0000 0097         davnr=0b00000001; kanalas=0;
	LDI  R30,LOW(1)
	MOV  R10,R30
	LDI  R30,LOW(0)
	STS  _kanalas,R30
; 0000 0098         adcDavApkl();
	RCALL _adcDavApkl
; 0000 0099      if (! (idav) & (davnr))   ;
	MOV  R30,R8
	RCALL __LNEGB1
	AND  R30,R10
; 0000 009A         davnr=0b00000010; kanalas=1;
	LDI  R30,LOW(2)
	MOV  R10,R30
	LDI  R30,LOW(1)
	STS  _kanalas,R30
; 0000 009B         adcDavApkl();
	RCALL _adcDavApkl
; 0000 009C      if (! (idav) & (davnr))   ;
	MOV  R30,R8
	RCALL __LNEGB1
	AND  R30,R10
; 0000 009D        davnr=0b00000100;   kanalas =2;
	LDI  R30,LOW(4)
	MOV  R10,R30
	LDI  R30,LOW(2)
	STS  _kanalas,R30
; 0000 009E         adcDavApkl();
	RCALL _adcDavApkl
; 0000 009F      if (! (idav) & (davnr))   ;
	MOV  R30,R8
	RCALL __LNEGB1
	AND  R30,R10
; 0000 00A0         davnr=0b00001000; kanalas=3;
	LDI  R30,LOW(8)
	MOV  R10,R30
	LDI  R30,LOW(3)
	STS  _kanalas,R30
; 0000 00A1         adcDavApkl();
	RCALL _adcDavApkl
; 0000 00A2      if (! (idav) & (davnr))  ;
	MOV  R30,R8
	RCALL __LNEGB1
	AND  R30,R10
; 0000 00A3 }
	RET
;
;
;//*********************  Uzlaikymas ns 22vienetu~13us******************************************
;static  void  delay_ns(char __count)
; 0000 00A8 {#asm  volatile
_delay_ns_G000:
;	__count -> Y+0
; 0000 00A9             ld r26,y;
            ld r26,y;
; 0000 00AA  _zyme:     dec r26;
 _zyme:     dec r26;
; 0000 00AB                nop;
               nop;
; 0000 00AC             brne  _zyme;
            brne  _zyme;
; 0000 00AD #endasm
; 0000 00AE __count=0;
	LDI  R30,LOW(0)
	ST   Y,R30
; 0000 00AF }
	ADIW R28,1
	RET

	.CSEG

	.DSEG

	.CSEG

	.CSEG

	.CSEG

	.CSEG

	.DSEG
_kanalas:
	.BYTE 0x1
_lygispr:
	.BYTE 0x4
_lygis:
	.BYTE 0x4
_adcjautrumas:
	.BYTE 0x2
__seed_G100:
	.BYTE 0x4

	.CSEG

	.CSEG
__ASRW4:
	ASR  R31
	ROR  R30
__ASRW3:
	ASR  R31
	ROR  R30
__ASRW2:
	ASR  R31
	ROR  R30
	ASR  R31
	ROR  R30
	RET

__LSRW4:
	LSR  R31
	ROR  R30
__LSRW3:
	LSR  R31
	ROR  R30
__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__LNEGB1:
	TST  R30
	LDI  R30,1
	BREQ __LNEGB1F
	CLR  R30
__LNEGB1F:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
